#line 1 "P:/_Electronique_/# LibStock #/mesure courant capteur  effet hall/Exemple_Main_For_PIC18F.c"
#line 27 "P:/_Electronique_/# LibStock #/mesure courant capteur  effet hall/Exemple_Main_For_PIC18F.c"
static float kA = 25.0;
static float kVref = 4.8828125e-3;
float an0, val;

char str[24];

void UART1_jump_a_line()
{
 UART1_Write(10);
 UART1_Write(13);
}

void InitTimer0()
{






 T0CON = 0xC0;
 TMR0L = 0x64;

 INTCON.TMR0IE = 1;
 INTCON.GIE=1;
}

unsigned long int t_;


void InitTimer1()
{
 T1CON = 0x01;
 TMR1IF_bit = 0;

 TMR1H = 0xF8;
 TMR1L = 0x30;
 TMR1IE_bit = 1;

}

unsigned long int t_x;
long int adc0_moy_x;
long int ac2_moy_x;
long int ac2_sum_x;

int j, aff;
unsigned int k, k_;
int adc0, ac, adc0_moy;
long int adc0_sum, adc0_moy_50;
long int ac2, ac2_sum, ac2_sum_t, ac2_moy, ac2_moy_50;

void interrupt(void)
{
 if(TMR0IF_bit)
 {
 PORTB = 255 ;

 INTCON.TMR0IF = 0;

 TMR0L = 0x64;

 adc0 = ADC_Read(0);
 ac = adc0 - adc0_moy;
 ac2 = ac * ac;


 if(j == 127)
 {
 adc0_sum += adc0;
 adc0_moy = adc0_sum >> 7;
 adc0_sum = 0;

 ac2_sum += ac2;

 ac2_sum_t = ac2_sum;
 ac2_moy = ac2_sum >> 7;
 ac2_sum = 0;

 j = 0;
 k++;
 adc0_moy_50 += adc0_moy;
 ac2_moy_50 += ac2_moy;
 if(k == 50)
 {

 t_x = t_;
 adc0_moy_x = adc0_moy_50;
 ac2_moy_x = ac2_moy_50;
 adc0_moy_50 = 0;
 ac2_moy_50 = 0;
 aff = 1;
 k_ = k;
 k = 0;
 }
 else aff = 0;
 }
 else
 {
 adc0_sum += adc0;
 ac2_sum += ac2;

 j++;
 }

 PORTB = 0 ;
 }

 if(TMR1IF_bit)
 {

 TMR1IF_bit = 0;

 PORTD = 1 ;

 TMR1H = 0xF8;
 TMR1L = 0x30;


 t_++;
 Delay_us(100);
 PORTD = 0 ;
 }
}




void main()
{
 TRISA = 0xFF;
 TRISB = 0;
 TRISD = 0;
 PORTA = 0 ;
 PORTB = 0 ;
 PORTD = 0 ;

 adc0_moy = 0;
 adc0_sum = 0;

 ac2_moy = 0;
 ac2_sum = 0;

 j = 0;
 k = 0;
 aff = 0;

 InitTimer0();
 t_ = 0;
 InitTimer1();

 ADCON1 = 0x82;

 UART1_Init(9600);

 Delay_ms(1000);
 PORTB = 255 ;

 UART1_jump_a_line();

 UART1_Write_Text("Start, using mikroC Firmware on PIC18 (18F4620-8MHz-64K ROM) v1.0.0.0");
 UART1_jump_a_line();
 UART1_Write_Text("Build : "  "20:12:41" );
 UART1_Write_Text(", "  "Apr 20 2018" );
 UART1_jump_a_line();

 Delay_ms(5000);
 PORTB = 0 ;

 while(1)
 {
 if(aff == 1)
 {
 val = (float) k_;

 aff = 0;
 val = 1.0 / val;

 UART1_Write_Text("Time: ");
 FloatToStr(t_x * 0.001, str);
 UART1_Write_Text(str);
 UART1_Write_Text("s , ");
 UART1_Write_Text("ADC0 Moy(");
 IntToStr(adc0_moy, str);
 UART1_Write_Text(str);
 UART1_Write_Text(" ) ");

 an0 = (float)adc0_moy_x * val;
 an0 *= kVref;
 FloatToStr(an0, str);
 UART1_Write_Text(str);
 UART1_Write_Text("V, K:");
 LongToStr(k_, str);
 UART1_Write_Text(str);
 UART1_Write_Text(" , ");

 val = (float)ac2_moy_x * val;
 if(val < 3) val = 0;
 val = sqrt(val) * kVref * kA;
 FloatToStr(val, str);
 UART1_Write_Text(str);
 UART1_Write_Text("A eff, ");
 val = val * 226.0;
 FloatToStr(val, str);
 UART1_Write_Text(str);
 UART1_Write_Text("VA");
 UART1_jump_a_line();
 }
 }
}
