
_UART1_jump_a_line:

;Exemple_Main_For_PIC18F.c,33 :: 		void UART1_jump_a_line()
;Exemple_Main_For_PIC18F.c,35 :: 		UART1_Write(10);
	MOVLW       10
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;Exemple_Main_For_PIC18F.c,36 :: 		UART1_Write(13);
	MOVLW       13
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;Exemple_Main_For_PIC18F.c,37 :: 		}
L_end_UART1_jump_a_line:
	RETURN      0
; end of _UART1_jump_a_line

_InitTimer0:

;Exemple_Main_For_PIC18F.c,39 :: 		void InitTimer0()
;Exemple_Main_For_PIC18F.c,47 :: 		T0CON         = 0xC0;
	MOVLW       192
	MOVWF       T0CON+0 
;Exemple_Main_For_PIC18F.c,48 :: 		TMR0L         = 0x64;
	MOVLW       100
	MOVWF       TMR0L+0 
;Exemple_Main_For_PIC18F.c,50 :: 		INTCON.TMR0IE = 1;    //enable the timer0 by setting TRM0IE flag
	BSF         INTCON+0, 5 
;Exemple_Main_For_PIC18F.c,51 :: 		INTCON.GIE=1;         //globle interrupt enable
	BSF         INTCON+0, 7 
;Exemple_Main_For_PIC18F.c,52 :: 		}
L_end_InitTimer0:
	RETURN      0
; end of _InitTimer0

_InitTimer1:

;Exemple_Main_For_PIC18F.c,57 :: 		void InitTimer1()
;Exemple_Main_For_PIC18F.c,59 :: 		T1CON         = 0x01;
	MOVLW       1
	MOVWF       T1CON+0 
;Exemple_Main_For_PIC18F.c,60 :: 		TMR1IF_bit         = 0;
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
;Exemple_Main_For_PIC18F.c,62 :: 		TMR1H         = 0xF8;
	MOVLW       248
	MOVWF       TMR1H+0 
;Exemple_Main_For_PIC18F.c,63 :: 		TMR1L         = 0x30;
	MOVLW       48
	MOVWF       TMR1L+0 
;Exemple_Main_For_PIC18F.c,64 :: 		TMR1IE_bit         = 1;
	BSF         TMR1IE_bit+0, BitPos(TMR1IE_bit+0) 
;Exemple_Main_For_PIC18F.c,66 :: 		}
L_end_InitTimer1:
	RETURN      0
; end of _InitTimer1

_interrupt:

;Exemple_Main_For_PIC18F.c,79 :: 		void interrupt(void)
;Exemple_Main_For_PIC18F.c,81 :: 		if(TMR0IF_bit)  // interrupt handler for the timer0 overflow
	BTFSS       TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
	GOTO        L_interrupt0
;Exemple_Main_For_PIC18F.c,83 :: 		PORTB = 255 ;
	MOVLW       255
	MOVWF       PORTB+0 
;Exemple_Main_For_PIC18F.c,85 :: 		INTCON.TMR0IF = 0;
	BCF         INTCON+0, 2 
;Exemple_Main_For_PIC18F.c,87 :: 		TMR0L         = 0x64;   // 156s
	MOVLW       100
	MOVWF       TMR0L+0 
;Exemple_Main_For_PIC18F.c,89 :: 		adc0 = ADC_Read(0);   // Get 10-bit results of AD conversion
	CLRF        FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _adc0+0 
	MOVF        R1, 0 
	MOVWF       _adc0+1 
;Exemple_Main_For_PIC18F.c,90 :: 		ac = adc0 - adc0_moy;  // retrais de la valeur moyenne pour avoir les valeurs alternatives centr sur le 0
	MOVF        _adc0_moy+0, 0 
	SUBWF       R0, 1 
	MOVF        _adc0_moy+1, 0 
	SUBWFB      R1, 1 
	MOVF        R0, 0 
	MOVWF       _ac+0 
	MOVF        R1, 0 
	MOVWF       _ac+1 
;Exemple_Main_For_PIC18F.c,91 :: 		ac2 = ac * ac;  // calcule de la valeur au carr
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVF        R0, 0 
	MOVWF       _ac2+0 
	MOVF        R1, 0 
	MOVWF       _ac2+1 
	MOVLW       0
	BTFSC       R1, 7 
	MOVLW       255
	MOVWF       _ac2+2 
	MOVWF       _ac2+3 
;Exemple_Main_For_PIC18F.c,94 :: 		if(j == 127)
	MOVLW       0
	XORWF       _j+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt18
	MOVLW       127
	XORWF       _j+0, 0 
L__interrupt18:
	BTFSS       STATUS+0, 2 
	GOTO        L_interrupt1
;Exemple_Main_For_PIC18F.c,96 :: 		adc0_sum += adc0;
	MOVF        _adc0+0, 0 
	ADDWF       _adc0_sum+0, 0 
	MOVWF       R1 
	MOVF        _adc0+1, 0 
	ADDWFC      _adc0_sum+1, 0 
	MOVWF       R2 
	MOVLW       0
	BTFSC       _adc0+1, 7 
	MOVLW       255
	ADDWFC      _adc0_sum+2, 0 
	MOVWF       R3 
	MOVLW       0
	BTFSC       _adc0+1, 7 
	MOVLW       255
	ADDWFC      _adc0_sum+3, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       _adc0_sum+0 
	MOVF        R2, 0 
	MOVWF       _adc0_sum+1 
	MOVF        R3, 0 
	MOVWF       _adc0_sum+2 
	MOVF        R4, 0 
	MOVWF       _adc0_sum+3 
;Exemple_Main_For_PIC18F.c,97 :: 		adc0_moy = adc0_sum >> 7;
	MOVLW       7
	MOVWF       R0 
	MOVF        R1, 0 
	MOVWF       R9 
	MOVF        R2, 0 
	MOVWF       R10 
	MOVF        R3, 0 
	MOVWF       R11 
	MOVF        R4, 0 
	MOVWF       R12 
	MOVF        R0, 0 
L__interrupt19:
	BZ          L__interrupt20
	RRCF        R12, 1 
	RRCF        R11, 1 
	RRCF        R10, 1 
	RRCF        R9, 1 
	BCF         R12, 7 
	BTFSC       R12, 6 
	BSF         R12, 7 
	ADDLW       255
	GOTO        L__interrupt19
L__interrupt20:
	MOVF        R9, 0 
	MOVWF       _adc0_moy+0 
	MOVF        R10, 0 
	MOVWF       _adc0_moy+1 
;Exemple_Main_For_PIC18F.c,98 :: 		adc0_sum = 0;
	CLRF        _adc0_sum+0 
	CLRF        _adc0_sum+1 
	CLRF        _adc0_sum+2 
	CLRF        _adc0_sum+3 
;Exemple_Main_For_PIC18F.c,100 :: 		ac2_sum += ac2;
	MOVF        _ac2+0, 0 
	ADDWF       _ac2_sum+0, 0 
	MOVWF       R5 
	MOVF        _ac2+1, 0 
	ADDWFC      _ac2_sum+1, 0 
	MOVWF       R6 
	MOVF        _ac2+2, 0 
	ADDWFC      _ac2_sum+2, 0 
	MOVWF       R7 
	MOVF        _ac2+3, 0 
	ADDWFC      _ac2_sum+3, 0 
	MOVWF       R8 
	MOVF        R5, 0 
	MOVWF       _ac2_sum+0 
	MOVF        R6, 0 
	MOVWF       _ac2_sum+1 
	MOVF        R7, 0 
	MOVWF       _ac2_sum+2 
	MOVF        R8, 0 
	MOVWF       _ac2_sum+3 
;Exemple_Main_For_PIC18F.c,102 :: 		ac2_sum_t = ac2_sum;
	MOVF        R5, 0 
	MOVWF       _ac2_sum_t+0 
	MOVF        R6, 0 
	MOVWF       _ac2_sum_t+1 
	MOVF        R7, 0 
	MOVWF       _ac2_sum_t+2 
	MOVF        R8, 0 
	MOVWF       _ac2_sum_t+3 
;Exemple_Main_For_PIC18F.c,103 :: 		ac2_moy  = ac2_sum >> 7;
	MOVLW       7
	MOVWF       R4 
	MOVF        R5, 0 
	MOVWF       R0 
	MOVF        R6, 0 
	MOVWF       R1 
	MOVF        R7, 0 
	MOVWF       R2 
	MOVF        R8, 0 
	MOVWF       R3 
	MOVF        R4, 0 
L__interrupt21:
	BZ          L__interrupt22
	RRCF        R3, 1 
	RRCF        R2, 1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R3, 7 
	BTFSC       R3, 6 
	BSF         R3, 7 
	ADDLW       255
	GOTO        L__interrupt21
L__interrupt22:
	MOVF        R0, 0 
	MOVWF       _ac2_moy+0 
	MOVF        R1, 0 
	MOVWF       _ac2_moy+1 
	MOVF        R2, 0 
	MOVWF       _ac2_moy+2 
	MOVF        R3, 0 
	MOVWF       _ac2_moy+3 
;Exemple_Main_For_PIC18F.c,104 :: 		ac2_sum = 0;
	CLRF        _ac2_sum+0 
	CLRF        _ac2_sum+1 
	CLRF        _ac2_sum+2 
	CLRF        _ac2_sum+3 
;Exemple_Main_For_PIC18F.c,106 :: 		j = 0;
	CLRF        _j+0 
	CLRF        _j+1 
;Exemple_Main_For_PIC18F.c,107 :: 		k++;
	INFSNZ      _k+0, 1 
	INCF        _k+1, 1 
;Exemple_Main_For_PIC18F.c,108 :: 		adc0_moy_50 += adc0_moy;
	MOVF        R9, 0 
	ADDWF       _adc0_moy_50+0, 1 
	MOVF        R10, 0 
	ADDWFC      _adc0_moy_50+1, 1 
	MOVLW       0
	BTFSC       R10, 7 
	MOVLW       255
	ADDWFC      _adc0_moy_50+2, 1 
	ADDWFC      _adc0_moy_50+3, 1 
;Exemple_Main_For_PIC18F.c,109 :: 		ac2_moy_50 += ac2_moy;
	MOVF        R0, 0 
	ADDWF       _ac2_moy_50+0, 1 
	MOVF        R1, 0 
	ADDWFC      _ac2_moy_50+1, 1 
	MOVF        R2, 0 
	ADDWFC      _ac2_moy_50+2, 1 
	MOVF        R3, 0 
	ADDWFC      _ac2_moy_50+3, 1 
;Exemple_Main_For_PIC18F.c,110 :: 		if(k == 50)
	MOVLW       0
	XORWF       _k+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt23
	MOVLW       50
	XORWF       _k+0, 0 
L__interrupt23:
	BTFSS       STATUS+0, 2 
	GOTO        L_interrupt2
;Exemple_Main_For_PIC18F.c,113 :: 		t_x = t_;
	MOVF        _t_+0, 0 
	MOVWF       _t_x+0 
	MOVF        _t_+1, 0 
	MOVWF       _t_x+1 
	MOVF        _t_+2, 0 
	MOVWF       _t_x+2 
	MOVF        _t_+3, 0 
	MOVWF       _t_x+3 
;Exemple_Main_For_PIC18F.c,114 :: 		adc0_moy_x = adc0_moy_50;
	MOVF        _adc0_moy_50+0, 0 
	MOVWF       _adc0_moy_x+0 
	MOVF        _adc0_moy_50+1, 0 
	MOVWF       _adc0_moy_x+1 
	MOVF        _adc0_moy_50+2, 0 
	MOVWF       _adc0_moy_x+2 
	MOVF        _adc0_moy_50+3, 0 
	MOVWF       _adc0_moy_x+3 
;Exemple_Main_For_PIC18F.c,115 :: 		ac2_moy_x = ac2_moy_50;
	MOVF        _ac2_moy_50+0, 0 
	MOVWF       _ac2_moy_x+0 
	MOVF        _ac2_moy_50+1, 0 
	MOVWF       _ac2_moy_x+1 
	MOVF        _ac2_moy_50+2, 0 
	MOVWF       _ac2_moy_x+2 
	MOVF        _ac2_moy_50+3, 0 
	MOVWF       _ac2_moy_x+3 
;Exemple_Main_For_PIC18F.c,116 :: 		adc0_moy_50 = 0;
	CLRF        _adc0_moy_50+0 
	CLRF        _adc0_moy_50+1 
	CLRF        _adc0_moy_50+2 
	CLRF        _adc0_moy_50+3 
;Exemple_Main_For_PIC18F.c,117 :: 		ac2_moy_50 = 0;
	CLRF        _ac2_moy_50+0 
	CLRF        _ac2_moy_50+1 
	CLRF        _ac2_moy_50+2 
	CLRF        _ac2_moy_50+3 
;Exemple_Main_For_PIC18F.c,118 :: 		aff = 1;
	MOVLW       1
	MOVWF       _aff+0 
	MOVLW       0
	MOVWF       _aff+1 
;Exemple_Main_For_PIC18F.c,119 :: 		k_ = k;
	MOVF        _k+0, 0 
	MOVWF       _k_+0 
	MOVF        _k+1, 0 
	MOVWF       _k_+1 
;Exemple_Main_For_PIC18F.c,120 :: 		k = 0;
	CLRF        _k+0 
	CLRF        _k+1 
;Exemple_Main_For_PIC18F.c,121 :: 		}
	GOTO        L_interrupt3
L_interrupt2:
;Exemple_Main_For_PIC18F.c,122 :: 		else aff = 0;
	CLRF        _aff+0 
	CLRF        _aff+1 
L_interrupt3:
;Exemple_Main_For_PIC18F.c,123 :: 		}
	GOTO        L_interrupt4
L_interrupt1:
;Exemple_Main_For_PIC18F.c,126 :: 		adc0_sum += adc0;
	MOVF        _adc0+0, 0 
	ADDWF       _adc0_sum+0, 1 
	MOVF        _adc0+1, 0 
	ADDWFC      _adc0_sum+1, 1 
	MOVLW       0
	BTFSC       _adc0+1, 7 
	MOVLW       255
	ADDWFC      _adc0_sum+2, 1 
	ADDWFC      _adc0_sum+3, 1 
;Exemple_Main_For_PIC18F.c,127 :: 		ac2_sum += ac2;
	MOVF        _ac2+0, 0 
	ADDWF       _ac2_sum+0, 1 
	MOVF        _ac2+1, 0 
	ADDWFC      _ac2_sum+1, 1 
	MOVF        _ac2+2, 0 
	ADDWFC      _ac2_sum+2, 1 
	MOVF        _ac2+3, 0 
	ADDWFC      _ac2_sum+3, 1 
;Exemple_Main_For_PIC18F.c,129 :: 		j++;
	INFSNZ      _j+0, 1 
	INCF        _j+1, 1 
;Exemple_Main_For_PIC18F.c,130 :: 		}
L_interrupt4:
;Exemple_Main_For_PIC18F.c,132 :: 		PORTB = 0 ;
	CLRF        PORTB+0 
;Exemple_Main_For_PIC18F.c,133 :: 		}
L_interrupt0:
;Exemple_Main_For_PIC18F.c,135 :: 		if(TMR1IF_bit) // interrupt handler for the timer1 overflow
	BTFSS       TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
	GOTO        L_interrupt5
;Exemple_Main_For_PIC18F.c,138 :: 		TMR1IF_bit = 0;
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
;Exemple_Main_For_PIC18F.c,140 :: 		PORTD = 1 ;
	MOVLW       1
	MOVWF       PORTD+0 
;Exemple_Main_For_PIC18F.c,142 :: 		TMR1H         = 0xF8;
	MOVLW       248
	MOVWF       TMR1H+0 
;Exemple_Main_For_PIC18F.c,143 :: 		TMR1L         = 0x30;
	MOVLW       48
	MOVWF       TMR1L+0 
;Exemple_Main_For_PIC18F.c,146 :: 		t_++;
	MOVLW       1
	ADDWF       _t_+0, 1 
	MOVLW       0
	ADDWFC      _t_+1, 1 
	ADDWFC      _t_+2, 1 
	ADDWFC      _t_+3, 1 
;Exemple_Main_For_PIC18F.c,147 :: 		Delay_us(100);
	MOVLW       66
	MOVWF       R13, 0
L_interrupt6:
	DECFSZ      R13, 1, 1
	BRA         L_interrupt6
	NOP
;Exemple_Main_For_PIC18F.c,148 :: 		PORTD = 0 ;
	CLRF        PORTD+0 
;Exemple_Main_For_PIC18F.c,149 :: 		}
L_interrupt5:
;Exemple_Main_For_PIC18F.c,150 :: 		}
L_end_interrupt:
L__interrupt17:
	RETFIE      1
; end of _interrupt

_main:

;Exemple_Main_For_PIC18F.c,155 :: 		void main()
;Exemple_Main_For_PIC18F.c,157 :: 		TRISA  = 0xFF;              // PORTA is input
	MOVLW       255
	MOVWF       TRISA+0 
;Exemple_Main_For_PIC18F.c,158 :: 		TRISB = 0;                  // PORTB is output
	CLRF        TRISB+0 
;Exemple_Main_For_PIC18F.c,159 :: 		TRISD = 0;                  // PORTD is output
	CLRF        TRISD+0 
;Exemple_Main_For_PIC18F.c,160 :: 		PORTA = 0 ;
	CLRF        PORTA+0 
;Exemple_Main_For_PIC18F.c,161 :: 		PORTB = 0 ;
	CLRF        PORTB+0 
;Exemple_Main_For_PIC18F.c,162 :: 		PORTD = 0 ;
	CLRF        PORTD+0 
;Exemple_Main_For_PIC18F.c,164 :: 		adc0_moy = 0;
	CLRF        _adc0_moy+0 
	CLRF        _adc0_moy+1 
;Exemple_Main_For_PIC18F.c,165 :: 		adc0_sum = 0;
	CLRF        _adc0_sum+0 
	CLRF        _adc0_sum+1 
	CLRF        _adc0_sum+2 
	CLRF        _adc0_sum+3 
;Exemple_Main_For_PIC18F.c,167 :: 		ac2_moy = 0;
	CLRF        _ac2_moy+0 
	CLRF        _ac2_moy+1 
	CLRF        _ac2_moy+2 
	CLRF        _ac2_moy+3 
;Exemple_Main_For_PIC18F.c,168 :: 		ac2_sum = 0;
	CLRF        _ac2_sum+0 
	CLRF        _ac2_sum+1 
	CLRF        _ac2_sum+2 
	CLRF        _ac2_sum+3 
;Exemple_Main_For_PIC18F.c,170 :: 		j = 0;
	CLRF        _j+0 
	CLRF        _j+1 
;Exemple_Main_For_PIC18F.c,171 :: 		k = 0;
	CLRF        _k+0 
	CLRF        _k+1 
;Exemple_Main_For_PIC18F.c,172 :: 		aff = 0;
	CLRF        _aff+0 
	CLRF        _aff+1 
;Exemple_Main_For_PIC18F.c,174 :: 		InitTimer0();
	CALL        _InitTimer0+0, 0
;Exemple_Main_For_PIC18F.c,175 :: 		t_ = 0;
	CLRF        _t_+0 
	CLRF        _t_+1 
	CLRF        _t_+2 
	CLRF        _t_+3 
;Exemple_Main_For_PIC18F.c,176 :: 		InitTimer1();
	CALL        _InitTimer1+0, 0
;Exemple_Main_For_PIC18F.c,178 :: 		ADCON1 = 0x82;  // Vref+ = VDD, Vref- = VSS, RA0  RA5 = ADCin
	MOVLW       130
	MOVWF       ADCON1+0 
;Exemple_Main_For_PIC18F.c,180 :: 		UART1_Init(9600);               // Initialize UART module at 9600 bps
	BSF         BAUDCON+0, 3, 0
	CLRF        SPBRGH+0 
	MOVLW       207
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;Exemple_Main_For_PIC18F.c,182 :: 		Delay_ms(1000);                  // Wait for to stabilize
	MOVLW       11
	MOVWF       R11, 0
	MOVLW       38
	MOVWF       R12, 0
	MOVLW       93
	MOVWF       R13, 0
L_main7:
	DECFSZ      R13, 1, 1
	BRA         L_main7
	DECFSZ      R12, 1, 1
	BRA         L_main7
	DECFSZ      R11, 1, 1
	BRA         L_main7
	NOP
	NOP
;Exemple_Main_For_PIC18F.c,183 :: 		PORTB = 255 ;
	MOVLW       255
	MOVWF       PORTB+0 
;Exemple_Main_For_PIC18F.c,185 :: 		UART1_jump_a_line();
	CALL        _UART1_jump_a_line+0, 0
;Exemple_Main_For_PIC18F.c,187 :: 		UART1_Write_Text("Start, using mikroC Firmware on PIC18 (18F4620-8MHz-64K ROM) v1.0.0.0");
	MOVLW       ?lstr1_Exemple_Main_For_PIC18F+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr1_Exemple_Main_For_PIC18F+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,188 :: 		UART1_jump_a_line();
	CALL        _UART1_jump_a_line+0, 0
;Exemple_Main_For_PIC18F.c,189 :: 		UART1_Write_Text("Build : " __TIME__);
	MOVLW       ?lstr2_Exemple_Main_For_PIC18F+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr2_Exemple_Main_For_PIC18F+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,190 :: 		UART1_Write_Text(", " __DATE__);
	MOVLW       ?lstr3_Exemple_Main_For_PIC18F+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr3_Exemple_Main_For_PIC18F+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,191 :: 		UART1_jump_a_line();
	CALL        _UART1_jump_a_line+0, 0
;Exemple_Main_For_PIC18F.c,193 :: 		Delay_ms(5000);                  // Wait for read version
	MOVLW       51
	MOVWF       R11, 0
	MOVLW       187
	MOVWF       R12, 0
	MOVLW       223
	MOVWF       R13, 0
L_main8:
	DECFSZ      R13, 1, 1
	BRA         L_main8
	DECFSZ      R12, 1, 1
	BRA         L_main8
	DECFSZ      R11, 1, 1
	BRA         L_main8
	NOP
	NOP
;Exemple_Main_For_PIC18F.c,194 :: 		PORTB = 0 ;
	CLRF        PORTB+0 
;Exemple_Main_For_PIC18F.c,196 :: 		while(1)
L_main9:
;Exemple_Main_For_PIC18F.c,198 :: 		if(aff == 1)  // affichage tous les 50 cycles
	MOVLW       0
	XORWF       _aff+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main25
	MOVLW       1
	XORWF       _aff+0, 0 
L__main25:
	BTFSS       STATUS+0, 2 
	GOTO        L_main11
;Exemple_Main_For_PIC18F.c,200 :: 		val = (float) k_;
	MOVF        _k_+0, 0 
	MOVWF       R0 
	MOVF        _k_+1, 0 
	MOVWF       R1 
	CALL        _word2double+0, 0
	MOVF        R0, 0 
	MOVWF       _val+0 
	MOVF        R1, 0 
	MOVWF       _val+1 
	MOVF        R2, 0 
	MOVWF       _val+2 
	MOVF        R3, 0 
	MOVWF       _val+3 
;Exemple_Main_For_PIC18F.c,202 :: 		aff = 0;
	CLRF        _aff+0 
	CLRF        _aff+1 
;Exemple_Main_For_PIC18F.c,203 :: 		val = 1.0 / val;
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	MOVLW       0
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVLW       127
	MOVWF       R3 
	CALL        _Div_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       _val+0 
	MOVF        R1, 0 
	MOVWF       _val+1 
	MOVF        R2, 0 
	MOVWF       _val+2 
	MOVF        R3, 0 
	MOVWF       _val+3 
;Exemple_Main_For_PIC18F.c,205 :: 		UART1_Write_Text("Time: ");
	MOVLW       ?lstr4_Exemple_Main_For_PIC18F+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr4_Exemple_Main_For_PIC18F+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,206 :: 		FloatToStr(t_x * 0.001, str);
	MOVF        _t_x+0, 0 
	MOVWF       R0 
	MOVF        _t_x+1, 0 
	MOVWF       R1 
	MOVF        _t_x+2, 0 
	MOVWF       R2 
	MOVF        _t_x+3, 0 
	MOVWF       R3 
	CALL        _longword2double+0, 0
	MOVLW       111
	MOVWF       R4 
	MOVLW       18
	MOVWF       R5 
	MOVLW       3
	MOVWF       R6 
	MOVLW       117
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_FloatToStr_fnum+0 
	MOVF        R1, 0 
	MOVWF       FARG_FloatToStr_fnum+1 
	MOVF        R2, 0 
	MOVWF       FARG_FloatToStr_fnum+2 
	MOVF        R3, 0 
	MOVWF       FARG_FloatToStr_fnum+3 
	MOVLW       _str+0
	MOVWF       FARG_FloatToStr_str+0 
	MOVLW       hi_addr(_str+0)
	MOVWF       FARG_FloatToStr_str+1 
	CALL        _FloatToStr+0, 0
;Exemple_Main_For_PIC18F.c,207 :: 		UART1_Write_Text(str);
	MOVLW       _str+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_str+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,208 :: 		UART1_Write_Text("s , ");
	MOVLW       ?lstr5_Exemple_Main_For_PIC18F+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr5_Exemple_Main_For_PIC18F+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,209 :: 		UART1_Write_Text("ADC0 Moy(");
	MOVLW       ?lstr6_Exemple_Main_For_PIC18F+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr6_Exemple_Main_For_PIC18F+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,210 :: 		IntToStr(adc0_moy, str);
	MOVF        _adc0_moy+0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVF        _adc0_moy+1, 0 
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       _str+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(_str+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;Exemple_Main_For_PIC18F.c,211 :: 		UART1_Write_Text(str);
	MOVLW       _str+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_str+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,212 :: 		UART1_Write_Text(" ) ");
	MOVLW       ?lstr7_Exemple_Main_For_PIC18F+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr7_Exemple_Main_For_PIC18F+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,214 :: 		an0  = (float)adc0_moy_x * val;
	MOVF        _adc0_moy_x+0, 0 
	MOVWF       R0 
	MOVF        _adc0_moy_x+1, 0 
	MOVWF       R1 
	MOVF        _adc0_moy_x+2, 0 
	MOVWF       R2 
	MOVF        _adc0_moy_x+3, 0 
	MOVWF       R3 
	CALL        _longint2double+0, 0
	MOVF        _val+0, 0 
	MOVWF       R4 
	MOVF        _val+1, 0 
	MOVWF       R5 
	MOVF        _val+2, 0 
	MOVWF       R6 
	MOVF        _val+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       _an0+0 
	MOVF        R1, 0 
	MOVWF       _an0+1 
	MOVF        R2, 0 
	MOVWF       _an0+2 
	MOVF        R3, 0 
	MOVWF       _an0+3 
;Exemple_Main_For_PIC18F.c,215 :: 		an0  *= kVref; // an0(V) = ADC*(Vref/1024)
	MOVF        Exemple_Main_For_PIC18F_kVref+0, 0 
	MOVWF       R4 
	MOVF        Exemple_Main_For_PIC18F_kVref+1, 0 
	MOVWF       R5 
	MOVF        Exemple_Main_For_PIC18F_kVref+2, 0 
	MOVWF       R6 
	MOVF        Exemple_Main_For_PIC18F_kVref+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       _an0+0 
	MOVF        R1, 0 
	MOVWF       _an0+1 
	MOVF        R2, 0 
	MOVWF       _an0+2 
	MOVF        R3, 0 
	MOVWF       _an0+3 
;Exemple_Main_For_PIC18F.c,216 :: 		FloatToStr(an0, str);
	MOVF        R0, 0 
	MOVWF       FARG_FloatToStr_fnum+0 
	MOVF        R1, 0 
	MOVWF       FARG_FloatToStr_fnum+1 
	MOVF        R2, 0 
	MOVWF       FARG_FloatToStr_fnum+2 
	MOVF        R3, 0 
	MOVWF       FARG_FloatToStr_fnum+3 
	MOVLW       _str+0
	MOVWF       FARG_FloatToStr_str+0 
	MOVLW       hi_addr(_str+0)
	MOVWF       FARG_FloatToStr_str+1 
	CALL        _FloatToStr+0, 0
;Exemple_Main_For_PIC18F.c,217 :: 		UART1_Write_Text(str);
	MOVLW       _str+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_str+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,218 :: 		UART1_Write_Text("V, K:");
	MOVLW       ?lstr8_Exemple_Main_For_PIC18F+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr8_Exemple_Main_For_PIC18F+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,219 :: 		LongToStr(k_, str);
	MOVF        _k_+0, 0 
	MOVWF       FARG_LongToStr_input+0 
	MOVF        _k_+1, 0 
	MOVWF       FARG_LongToStr_input+1 
	MOVLW       0
	MOVWF       FARG_LongToStr_input+2 
	MOVWF       FARG_LongToStr_input+3 
	MOVLW       _str+0
	MOVWF       FARG_LongToStr_output+0 
	MOVLW       hi_addr(_str+0)
	MOVWF       FARG_LongToStr_output+1 
	CALL        _LongToStr+0, 0
;Exemple_Main_For_PIC18F.c,220 :: 		UART1_Write_Text(str);
	MOVLW       _str+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_str+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,221 :: 		UART1_Write_Text(" , ");
	MOVLW       ?lstr9_Exemple_Main_For_PIC18F+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr9_Exemple_Main_For_PIC18F+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,223 :: 		val  = (float)ac2_moy_x * val;
	MOVF        _ac2_moy_x+0, 0 
	MOVWF       R0 
	MOVF        _ac2_moy_x+1, 0 
	MOVWF       R1 
	MOVF        _ac2_moy_x+2, 0 
	MOVWF       R2 
	MOVF        _ac2_moy_x+3, 0 
	MOVWF       R3 
	CALL        _longint2double+0, 0
	MOVF        _val+0, 0 
	MOVWF       R4 
	MOVF        _val+1, 0 
	MOVWF       R5 
	MOVF        _val+2, 0 
	MOVWF       R6 
	MOVF        _val+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       _val+0 
	MOVF        R1, 0 
	MOVWF       _val+1 
	MOVF        R2, 0 
	MOVWF       _val+2 
	MOVF        R3, 0 
	MOVWF       _val+3 
;Exemple_Main_For_PIC18F.c,224 :: 		if(val < 3) val = 0; // annulation des valeurs faible parasite
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       64
	MOVWF       R6 
	MOVLW       128
	MOVWF       R7 
	CALL        _Compare_Double+0, 0
	MOVLW       1
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R0 
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main12
	CLRF        _val+0 
	CLRF        _val+1 
	CLRF        _val+2 
	CLRF        _val+3 
L_main12:
;Exemple_Main_For_PIC18F.c,225 :: 		val = sqrt(val) * kVref * kA; // courant efficace dans le capteur en A
	MOVF        _val+0, 0 
	MOVWF       FARG_sqrt_x+0 
	MOVF        _val+1, 0 
	MOVWF       FARG_sqrt_x+1 
	MOVF        _val+2, 0 
	MOVWF       FARG_sqrt_x+2 
	MOVF        _val+3, 0 
	MOVWF       FARG_sqrt_x+3 
	CALL        _sqrt+0, 0
	MOVF        Exemple_Main_For_PIC18F_kVref+0, 0 
	MOVWF       R4 
	MOVF        Exemple_Main_For_PIC18F_kVref+1, 0 
	MOVWF       R5 
	MOVF        Exemple_Main_For_PIC18F_kVref+2, 0 
	MOVWF       R6 
	MOVF        Exemple_Main_For_PIC18F_kVref+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        Exemple_Main_For_PIC18F_kA+0, 0 
	MOVWF       R4 
	MOVF        Exemple_Main_For_PIC18F_kA+1, 0 
	MOVWF       R5 
	MOVF        Exemple_Main_For_PIC18F_kA+2, 0 
	MOVWF       R6 
	MOVF        Exemple_Main_For_PIC18F_kA+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       _val+0 
	MOVF        R1, 0 
	MOVWF       _val+1 
	MOVF        R2, 0 
	MOVWF       _val+2 
	MOVF        R3, 0 
	MOVWF       _val+3 
;Exemple_Main_For_PIC18F.c,226 :: 		FloatToStr(val, str);
	MOVF        R0, 0 
	MOVWF       FARG_FloatToStr_fnum+0 
	MOVF        R1, 0 
	MOVWF       FARG_FloatToStr_fnum+1 
	MOVF        R2, 0 
	MOVWF       FARG_FloatToStr_fnum+2 
	MOVF        R3, 0 
	MOVWF       FARG_FloatToStr_fnum+3 
	MOVLW       _str+0
	MOVWF       FARG_FloatToStr_str+0 
	MOVLW       hi_addr(_str+0)
	MOVWF       FARG_FloatToStr_str+1 
	CALL        _FloatToStr+0, 0
;Exemple_Main_For_PIC18F.c,227 :: 		UART1_Write_Text(str);
	MOVLW       _str+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_str+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,228 :: 		UART1_Write_Text("A eff, ");
	MOVLW       ?lstr10_Exemple_Main_For_PIC18F+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr10_Exemple_Main_For_PIC18F+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,229 :: 		val = val * 226.0;
	MOVF        _val+0, 0 
	MOVWF       R0 
	MOVF        _val+1, 0 
	MOVWF       R1 
	MOVF        _val+2, 0 
	MOVWF       R2 
	MOVF        _val+3, 0 
	MOVWF       R3 
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       98
	MOVWF       R6 
	MOVLW       134
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       _val+0 
	MOVF        R1, 0 
	MOVWF       _val+1 
	MOVF        R2, 0 
	MOVWF       _val+2 
	MOVF        R3, 0 
	MOVWF       _val+3 
;Exemple_Main_For_PIC18F.c,230 :: 		FloatToStr(val, str);
	MOVF        R0, 0 
	MOVWF       FARG_FloatToStr_fnum+0 
	MOVF        R1, 0 
	MOVWF       FARG_FloatToStr_fnum+1 
	MOVF        R2, 0 
	MOVWF       FARG_FloatToStr_fnum+2 
	MOVF        R3, 0 
	MOVWF       FARG_FloatToStr_fnum+3 
	MOVLW       _str+0
	MOVWF       FARG_FloatToStr_str+0 
	MOVLW       hi_addr(_str+0)
	MOVWF       FARG_FloatToStr_str+1 
	CALL        _FloatToStr+0, 0
;Exemple_Main_For_PIC18F.c,231 :: 		UART1_Write_Text(str);
	MOVLW       _str+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_str+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,232 :: 		UART1_Write_Text("VA");
	MOVLW       ?lstr11_Exemple_Main_For_PIC18F+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr11_Exemple_Main_For_PIC18F+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;Exemple_Main_For_PIC18F.c,233 :: 		UART1_jump_a_line();
	CALL        _UART1_jump_a_line+0, 0
;Exemple_Main_For_PIC18F.c,234 :: 		}
L_main11:
;Exemple_Main_For_PIC18F.c,235 :: 		}
	GOTO        L_main9
;Exemple_Main_For_PIC18F.c,236 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
